#![feature(proc_macro_hygiene, decl_macro)]

extern crate log;
#[macro_use]
extern crate rocket;
extern crate tera;

use miniserde::{json, Serialize};
use rocket::{
    fs::{relative, FileServer},
    get, routes,
};
use rocket_dyn_templates::Template;

#[derive(Debug, Serialize)]
struct FlashContext {
    flash_name: Option<String>,
    flash_msg: Option<String>,
}

#[get("/art")]
fn art() -> Template {
    let context = FlashContext {
        flash_name: None,
        flash_msg: None,
    };
    Template::render("art", json::to_string(&context))
}

#[get("/background")]
fn background() -> Template {
    let context = FlashContext {
        flash_name: None,
        flash_msg: None,
    };
    Template::render("background", json::to_string(&context))
}

#[get("/bacteria")]
fn bacteria() -> Template {
    let context = FlashContext {
        flash_name: None,
        flash_msg: None,
    };
    Template::render("bacteria", json::to_string(&context))
}

#[get("/bacteria/sauerkraut-beginnings")]
fn bacteria_sauerkraut_beginnings() -> Template {
    let context = FlashContext {
        flash_name: None,
        flash_msg: None,
    };
    Template::render("bacteria/sauerkraut_beginnings", json::to_string(&context))
}

#[get("/bacteria/sauerkraut-bottled")]
fn bacteria_sauerkraut_bottled() -> Template {
    let context = FlashContext {
        flash_name: None,
        flash_msg: None,
    };
    Template::render("bacteria/sauerkraut_bottled", json::to_string(&context))
}

#[get("/computers")]
fn computers() -> Template {
    let context = FlashContext {
        flash_name: None,
        flash_msg: None,
    };
    Template::render("computers", json::to_string(&context))
}

#[get("/computers/esp8266-dht11")]
fn computers_esp8266_dht11() -> Template {
    let context = FlashContext {
        flash_name: None,
        flash_msg: None,
    };
    Template::render("computers/esp8266_dht11", json::to_string(&context))
}

#[get("/computers/i2c-adventures")]
fn computers_i2c_adventures() -> Template {
    let context = FlashContext {
        flash_name: None,
        flash_msg: None,
    };
    Template::render("computers/i2c_adventures", json::to_string(&context))
}

#[get("/computers/rust-compilation")]
fn computers_rust_compilation() -> Template {
    let context = FlashContext {
        flash_name: None,
        flash_msg: None,
    };
    Template::render("computers/rust_compilation", json::to_string(&context))
}

#[get("/fungi")]
fn fungi() -> Template {
    let context = FlashContext {
        flash_name: None,
        flash_msg: None,
    };
    Template::render("fungi", json::to_string(&context))
}

#[get("/fungi/design-patterns")]
fn fungi_design_patterns() -> Template {
    let context = FlashContext {
        flash_name: None,
        flash_msg: None,
    };
    Template::render("fungi/design_patterns", json::to_string(&context))
}

#[get("/fungi/glossary")]
fn fungi_glossary() -> Template {
    let context = FlashContext {
        flash_name: None,
        flash_msg: None,
    };
    Template::render("fungi/glossary", json::to_string(&context))
}

#[get("/fungi/grow-forests")]
fn fungi_grow_forests() -> Template {
    let context = FlashContext {
        flash_name: None,
        flash_msg: None,
    };
    Template::render("fungi/grow_forests", json::to_string(&context))
}

#[get("/fungi/grow-together")]
fn fungi_grow_together() -> Template {
    let context = FlashContext {
        flash_name: None,
        flash_msg: None,
    };
    Template::render("fungi/grow_together", json::to_string(&context))
}

#[get("/fungi/lichen-space")]
fn fungi_lichen_space() -> Template {
    let context = FlashContext {
        flash_name: None,
        flash_msg: None,
    };
    Template::render("fungi/lichen_space", json::to_string(&context))
}

#[get("/fungi/network-resilience")]
fn fungi_network_resilience() -> Template {
    let context = FlashContext {
        flash_name: None,
        flash_msg: None,
    };
    Template::render("fungi/network_resilience", json::to_string(&context))
}

#[get("/fungi/photo-guide")]
fn fungi_photo_guide() -> Template {
    let context = FlashContext {
        flash_name: None,
        flash_msg: None,
    };
    Template::render("fungi/photo_guide", json::to_string(&context))
}

#[get("/fungi/reading-list")]
fn fungi_reading_list() -> Template {
    let context = FlashContext {
        flash_name: None,
        flash_msg: None,
    };
    Template::render("fungi/reading_list", json::to_string(&context))
}

#[get("/")]
fn home() -> Template {
    let context = FlashContext {
        flash_name: None,
        flash_msg: None,
    };
    Template::render("home", json::to_string(&context))
}

#[get("/lists")]
fn lists() -> Template {
    let context = FlashContext {
        flash_name: None,
        flash_msg: None,
    };
    Template::render("lists", json::to_string(&context))
}

#[get("/meditation")]
fn meditation() -> Template {
    let context = FlashContext {
        flash_name: None,
        flash_msg: None,
    };
    Template::render("meditation", json::to_string(&context))
}

#[get("/plants")]
fn plants() -> Template {
    let context = FlashContext {
        flash_name: None,
        flash_msg: None,
    };
    Template::render("plants", json::to_string(&context))
}

#[get("/plants/aloe-there")]
fn plants_aloe_there() -> Template {
    let context = FlashContext {
        flash_name: None,
        flash_msg: None,
    };
    Template::render("plants/aloe_there", json::to_string(&context))
}

#[get("/plants/blueberry-dance")]
fn plants_blueberry_dance() -> Template {
    let context = FlashContext {
        flash_name: None,
        flash_msg: None,
    };
    Template::render("plants/blueberry_dance", json::to_string(&context))
}

#[get("/plants/botanical-deceptions")]
fn plants_botanical_deceptions() -> Template {
    let context = FlashContext {
        flash_name: None,
        flash_msg: None,
    };
    Template::render("plants/botanical_deceptions", json::to_string(&context))
}

#[get("/plants/potato-tech")]
fn plants_potato_tech() -> Template {
    let context = FlashContext {
        flash_name: None,
        flash_msg: None,
    };
    Template::render("plants/potato_tech", json::to_string(&context))
}

#[get("/projects")]
fn projects() -> Template {
    let context = FlashContext {
        flash_name: None,
        flash_msg: None,
    };
    Template::render("projects", json::to_string(&context))
}

#[get("/support")]
fn support() -> Template {
    let context = FlashContext {
        flash_name: None,
        flash_msg: None,
    };
    Template::render("support", json::to_string(&context))
}

#[catch(404)]
fn not_found() -> Template {
    debug!("404 Page Not Found");
    let context = FlashContext {
        flash_name: Some("error".to_string()),
        flash_msg: Some("No resource found for given URL".to_string()),
    };
    Template::render("not_found", json::to_string(&context))
}

#[launch]
fn rocket() -> _ {
    rocket::build()
        .mount(
            "/",
            routes![
                art,
                background,
                bacteria,
                bacteria_sauerkraut_beginnings,
                bacteria_sauerkraut_bottled,
                computers,
                computers_esp8266_dht11,
                computers_i2c_adventures,
                computers_rust_compilation,
                fungi,
                fungi_design_patterns,
                fungi_glossary,
                fungi_grow_forests,
                fungi_grow_together,
                fungi_lichen_space,
                fungi_network_resilience,
                fungi_photo_guide,
                fungi_reading_list,
                home,
                lists,
                meditation,
                plants,
                plants_aloe_there,
                plants_blueberry_dance,
                plants_botanical_deceptions,
                plants_potato_tech,
                projects,
                support
            ],
        )
        .mount("/", FileServer::from(relative!("static")))
        .register("/", catchers![not_found])
        .attach(Template::fairing())
}
